/*************************************************************************
 * Copyright (C) 2017-2018 Barcelona Supercomputing Center               *
 *                         Centro Nacional de Supercomputacion           *
 * All rights reserved.                                                  *
 *                                                                       *
 * This file is part of the NORNS Data Scheduler, a service that allows  *
 * other programs to start, track and manage asynchronous transfers of   *
 * data resources transfers requests between different storage backends. *
 *                                                                       *
 * See AUTHORS file in the top level directory for information           *
 * regarding developers and contributors.                                *
 *                                                                       *
 * The NORNS Data Scheduler is free software: you can redistribute it    *
 * and/or modify it under the terms of the GNU Lesser General Public     *
 * License as published by the Free Software Foundation, either          *
 * version 3 of the License, or (at your option) any later version.      *
 *                                                                       *
 * The NORNS Data Scheduler is distributed in the hope that it will be   *
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  *
 * Lesser General Public License for more details.                       *
 *                                                                       *
 * You should have received a copy of the GNU Lesser General             *
 * Public License along with the NORNS Data Scheduler.  If not, see      *
 * <http://www.gnu.org/licenses/>.                                       *
 *************************************************************************/

#ifndef __NORNS_BACKENDS_HPP__
#define  __NORNS_BACKENDS_HPP__

#include <memory>
#include "backends/backend-base.hpp"
#include "backends/process-memory.hpp"
#include "backends/remote-backend.hpp"
#include "backends/lustre-fs.hpp"
#include "backends/posix-fs.hpp"
#include "backends/nvml-dax.hpp"

namespace norns {
namespace storage {

    constexpr static const auto memory_nsid = "[[internal::memory]]";

    static const auto process_memory_backend = std::make_shared<detail::process_memory>(memory_nsid);
//    static const auto remote_backend = std::make_shared<detail::remote_backend>();
} // namespace storage
} // namespace norns

#endif /* __NORNS_BACKENDS_HPP__ */

